#ifndef _common_hh_
#define _common_hh_

#include <string>
#include <vector>
#include <set>
#include <list>
#include <map>

#define debug(A) if((debugLevel&(A))==(A)) cout 
#define rout if(reduce) cout << linie << ": "
#define TREE if(tree)
#define CODE if(code)
#define PARSE if(parse)

class Token;
class Symbol;
class RegExpr;
class Rule;
class RENode;
class Tree;

typedef vector<Token*> TokenVector;

typedef vector<Token*> TokenString;
typedef vector<Token*>::iterator TokenI;

typedef list<RENode*> RENodeList;
typedef list<RENode*>::iterator RENodeI;

typedef vector<string> StringVector;
typedef set<string> StringSet;

#endif
